/*
 File: sp_2sym.cpp
 Date and Time: Fri Jan 30 18:50:21 2015 
*/
#include "sp_2.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_sp_2;// grammar's ns
// first set terminals
// monolithic grammar --- no thread
void 
Csp_2::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rg_:{
       Rg* sym;
     if(re->rule_ == 0){
       sym = new Rg(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rg*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rs_:{
       Rs* sym;
     if(re->rule_ == 0){
       sym = new Rs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs2_Rs_:{
       Rs* sym;
     if(re->rule_ == 0){
       sym = new Rs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs3_Rs_:{
       Rs* sym;
     if(re->rule_ == 0){
       sym = new Rs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs4_Rs_:{
       Rs* sym;
     if(re->rule_ == 0){
       sym = new Rs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_Ra_:{
       Ra* sym;
     if(re->rule_ == 0){
       sym = new Ra(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ra*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rb_:{
       Rb* sym;
     if(re->rule_ == 0){
       sym = new Rb(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rb*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    default: return;
   }
}
